module Rory
  class Request < ::Rack::Request
    # Returns the unique request id, which is based off either the X-Request-Id header that can
    # be generated by a firewall, load balancer, or web server or by the RequestId middleware
    # (which sets the rory.request_id environment variable).
    #
    # This unique ID is useful for tracing a request from end-to-end as part of logging or debugging.
    # This relies on the rack variable set by the Rory::RequestId middleware.
    def uuid
      @uuid ||= env["rory.request_id"]
    end
  end
end
